#ifndef	lint
static char sccsid[] = "@(#)talk.c  2.0 [Lars Hammarstrand] 88-11-23";
static char orgid[] = "@(#)talk.c  1.2 [Nigel Holder (C) -  Baddow] 04/12/85";
#endif


/****************************************************************************
*
*	VERS 2.0 Author: Lars Hammarstrand.	(rewritten from 1.2)
*	VERS 1.2 Orginal Author:  Nigel Holder	(ver 1.2 04/12/85)
*
*
*	VERS 2.0 HISTORY: (Lars Hammarstrand)
*
*	1)	fixed erasechar to work.
*	2)	added a message queue as a communikation channel instead
*		of named pipes. (much faster)
*	3)	added realtime updates of screen.
*	4)	added a realtime keyboard-read process.
*	5)	replaced and cleaned up exit functions.
*	6)	cleaned up clock funcktions so it will show true elapsed time.
*
*
*	VERS 1.2 HISTORY: (Nigel Holder)
*
*	Date     :  12 June 1985
*		     4 December 1985		changed elapsed time stuff
*						to be synchronous to windows
*
*	Copyright (C) 1986  by Nigel Holder
*
*	   Permission to use this program is granted, provided it is not
*	sold, or distributed for direct commercial advantage, and includes
*	the copyright notice and this clause.
*
*
*	   Talk - an interactive communication program that allows users
*	to talk on a character basis (as opposed to a line basis, as for
*	the system write utility).
*
*	   Written for System V as it uses named pipes !
*	   (and BSD already has a talk utility).
*
*	Old 1.2 bugs:
*
*	1.   Not as good as BSD talk, but it suffices.
*	     (restricted to current host machine)
*
*	2.   Really need select() type statement (BSD) instead of sleeping
*	     for 1 second between no input or output activity.
*	     (version 8 should fix this).
*
*	3.   Should check for name fields in dividewin overflowing screenwidth
*
*	4.   Probably should disable CTRL-c stopping program when connected.
*
****************************************************************************/

#include "defs.h"

int	connected = FALSE;			/* whether actually talking  */
int	time_changed = FALSE;			/* to update elapsed time  */

WINDOW	*mywin, *hiswin, *dividewin;		/* the three windows  */
int	hispid, mypid, readpid, msgid;

char	tmp[BUFSIZ];				/* general purpose !  */
char	tempfile [40];
char	*myname	= NULL;
char	*hisname = NULL;
char	*histty = NULL;
char	*progname;

char	delchar;
key_t	key;

main (argc, argv)
int	argc;
char	*argv[];
{

	if (progname = strrchr (argv[0], '/'))
		++progname;
	else
		progname = argv[0];

	if (argc < 2)
	{
		fprintf (stderr, "usage: %s user [tty]\n", progname);
		exit (1);
	}

	hisname = argv[1];

	if (argc > 2)
		histty = argv[2];

	if ((myname = getlogin()) == NULL)
	{
		fprintf (stderr, "You don't exist. Go away.\n");
		exit (2);
	}
	
	signal (SIGINT, SIG_IGN);		/*  play safe  */
	signal (SIGHUP, SIG_IGN);
	signal (SIGQUIT, SIG_IGN);

	screen_init ();			/*  set up windows  */

	signal (SIGINT, interrupt);	/*  gracefully trap signals  */
	signal (SIGHUP, interrupt);
	signal (SIGQUIT, interrupt);
	signal (SIGALRM, clock_tick);	/* increment clock counter */

	doconnect ();			/*  tell'm I want'o talk with'm */
	talk ();			/*  let your fingers do the walking */

	/*NOTREACHED*/
}


